/*
 * Licensed Materials - Property of IBM
 *
 * com.ibm.etools.c
 *
 *  Copyright IBM Corporation 2004. All Rights Reserved. 
 *
 * Note to U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */
package com.ibm.etools.c.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.util.InternalEList;

import com.ibm.etools.c.CDerivableType;
import com.ibm.etools.c.CPackage;
import com.ibm.etools.c.CPointer;
import com.ibm.etools.c.CTypedElement;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Pointer</b></em>'. <!-- end-user-doc -->
 * <p>
 * </p>
 * 
 * @generated
 */
public class CPointerImpl extends CDerivedImpl implements CPointer {
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected CPointerImpl() {
        super();
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected EClass eStaticClass() {
        return CPackage.eINSTANCE.getCPointer();
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
        if (featureID >= 0) {
            switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
            case CPackage.CPOINTER__TD_LANG_TYPED_ELEMENT:
                return ((InternalEList) getTdLangTypedElement()).basicAdd(otherEnd, msgs);
            case CPackage.CPOINTER__CONTAINER:
                if (eContainer != null)
                    msgs = eBasicRemoveFromContainer(msgs);
                return eBasicSetContainer(otherEnd, CPackage.CPOINTER__CONTAINER, msgs);
            default:
                return eDynamicInverseAdd(otherEnd, featureID, baseClass, msgs);
            }
        }
        if (eContainer != null)
            msgs = eBasicRemoveFromContainer(msgs);
        return eBasicSetContainer(otherEnd, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
        if (featureID >= 0) {
            switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
            case CPackage.CPOINTER__TD_LANG_TYPED_ELEMENT:
                return ((InternalEList) getTdLangTypedElement()).basicRemove(otherEnd, msgs);
            case CPackage.CPOINTER__CONTAINER:
                return eBasicSetContainer(null, CPackage.CPOINTER__CONTAINER, msgs);
            default:
                return eDynamicInverseRemove(otherEnd, featureID, baseClass, msgs);
            }
        }
        return eBasicSetContainer(null, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public NotificationChain eBasicRemoveFromContainer(NotificationChain msgs) {
        if (eContainerFeatureID >= 0) {
            switch (eContainerFeatureID) {
            case CPackage.CPOINTER__CONTAINER:
                return ((InternalEObject) eContainer).eInverseRemove(this, CPackage.CTYPED_ELEMENT__CONTAINS, CTypedElement.class, msgs);
            default:
                return eDynamicBasicRemoveFromContainer(msgs);
            }
        }
        return ((InternalEObject) eContainer).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - eContainerFeatureID, null, msgs);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public Object eGet(EStructuralFeature eFeature, boolean resolve) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case CPackage.CPOINTER__NAME:
            return getName();
        case CPackage.CPOINTER__TD_LANG_TYPED_ELEMENT:
            return getTdLangTypedElement();
        case CPackage.CPOINTER__DERIVES:
            if (resolve)
                return getDerives();
            return basicGetDerives();
        case CPackage.CPOINTER__CONTAINER:
            return getContainer();
        }
        return eDynamicGet(eFeature, resolve);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void eSet(EStructuralFeature eFeature, Object newValue) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case CPackage.CPOINTER__NAME:
            setName((String) newValue);
            return;
        case CPackage.CPOINTER__TD_LANG_TYPED_ELEMENT:
            getTdLangTypedElement().clear();
            getTdLangTypedElement().addAll((Collection) newValue);
            return;
        case CPackage.CPOINTER__DERIVES:
            setDerives((CDerivableType) newValue);
            return;
        case CPackage.CPOINTER__CONTAINER:
            setContainer((CTypedElement) newValue);
            return;
        }
        eDynamicSet(eFeature, newValue);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void eUnset(EStructuralFeature eFeature) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case CPackage.CPOINTER__NAME:
            unsetName();
            return;
        case CPackage.CPOINTER__TD_LANG_TYPED_ELEMENT:
            getTdLangTypedElement().clear();
            return;
        case CPackage.CPOINTER__DERIVES:
            setDerives((CDerivableType) null);
            return;
        case CPackage.CPOINTER__CONTAINER:
            setContainer((CTypedElement) null);
            return;
        }
        eDynamicUnset(eFeature);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public boolean eIsSet(EStructuralFeature eFeature) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case CPackage.CPOINTER__NAME:
            return isSetName();
        case CPackage.CPOINTER__TD_LANG_TYPED_ELEMENT:
            return tdLangTypedElement != null && !tdLangTypedElement.isEmpty();
        case CPackage.CPOINTER__DERIVES:
            return derives != null;
        case CPackage.CPOINTER__CONTAINER:
            return getContainer() != null;
        }
        return eDynamicIsSet(eFeature);
    }

} //CPointerImpl
